package controller 
{
	import flash.display.DisplayObject;
	import gameobjects.Dragon;
	import gameobjects.Obstacle;
	/**
	 * Integrates all around neccessary Properties.
	 * 
	 * @author GS
	 */
	public class CollisionController 
	{
		
		private static var _obstacles:Vector.<Obstacle> = new Vector.<Obstacle>();
		private static var _dragons:Vector.<Dragon> = new Vector.<Dragon>();
		
		public function CollisionController() 
		{
			
		}
		
		//Obstacles
		public function collisionWithObstacles(dragon:Dragon):Obstacle
		{
			var _obstacles:Vector.<Obstacle> = CollisionController._obstacles;
			var i:int = 0;
			var l:int = _obstacles.length;
			for (i; i < l; i++) 
			{
				var item:Obstacle = _obstacles[i];
				
				if (dragon.hitTestObject(item)) return item;
			}
			
			return null;
		}
		
		public function addObstacle(obstacle:Obstacle):void 
		{
			CollisionController._obstacles.push(obstacle);
		}
		
		public function removeObstacle(obstacle:Obstacle):void 
		{
			CollisionController._obstacles.splice(_obstacles.indexOf(obstacle), 1);
		}
		
		//Dragons
		public function collisionWithDragons(collider:DisplayObject):Dragon
		{
			var _dragons:Vector.<Dragon> = CollisionController._dragons;
			var i:int = 0;
			var l:int = _dragons.length;
			for (i; i < l; i++) 
			{
				var item:Dragon = _dragons[i];
				
				if (item != collider && collider.hitTestObject(item)) return item;
			}
			
			return null;
		}
		
		public function addDragon(dragon:Dragon):void 
		{
			CollisionController._dragons.push(dragon);
		}
		
		public function removeDragon(dragon:Dragon):void 
		{
			CollisionController._dragons.splice(_dragons.indexOf(dragon), 1);
		}
		
	}

}