package controller 
{
	import gameobjects.Dragon;

	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.Socket;
	/**
	 * Connects to Server
	 * 
	 * @author GS
	 */
	public class ConnectionController extends EventDispatcher
	{
		private var _s:Socket;
		private var _dd:DragonDeltaVO;
		private var _initConnect:Boolean;
		
		public function ConnectionController() 
		{
			_initConnect = true;
			_dd = new DragonDeltaVO(0, 0, 0, 0);
			//_s = new Socket("192.168.70.112", 1337);
			_s = new Socket("127.0.0.1", 1337);
			
			_s.addEventListener(Event.CONNECT, onConnect);
			_s.addEventListener(ProgressEvent.SOCKET_DATA, onSocketData);
			
			_s.addEventListener(Event.CLOSE, onTrace);
			_s.addEventListener(IOErrorEvent.IO_ERROR, onTrace);
			_s.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onTrace);
		}
		
		public function initPlayer(d:Dragon):void 
		{
			d.addEventListener(DragonEvent.ACTION, onPlayerAction);
		}
		
		private function onPlayerAction(e:DragonEvent):void 
		{
			if (_s.connected)
			{
				_s.writeObject(new DragonDeltaVO(e.target.id, e.target.x, e.target.y, e.action));
				_s.flush();
			}
		}
		
		private function onConnect(e:Event):void 
		{
			trace("Connected" + _s.endian + _s.objectEncoding);
			
			_s.writeUTFBytes("INIT");
			_s.flush();
		}
		
		private function onSocketData(e:Event):void 
		{
			if (_initConnect) //Crappy check if inits
			{
				dispatchEvent(new ConnectionEvent(ConnectionEvent.CONNECT, (new DragonDeltaVO(_s.readByte(), _s.readShort(), _s.readShort(), DragonAction.SPAWN))));
				_initConnect = false;
				
				return;
			}
			
			while (_s.bytesAvailable > 5)
			{
				var o:Object = _s.readObject();
				_dd.id = o.id;
				_dd.x = o.x;
				_dd.y = o.y;
				_dd.action = o.action;
				trace(_dd.id, _dd.action);
				dispatchEvent(new ConnectionEvent(ConnectionEvent.UPDATE, _dd));
			}
		}
		
		private function onTrace(e:Event):void 
		{
			trace(e);
		}
	}

}