package controller 
{
	import gameobjects.Dragon;

	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	
	/**
	 * Controlls the Input and reactions of the PLayer Dragon
	 * 
	 * @author GS
	 */
	public class DragonController 
	{
		public var dragon:Dragon;
		private var _allowedUpKey:int;
		
		public function DragonController()
		{
			
		}
		
		public function initDragon(dragon:Dragon, playerStage:Stage = null):void //set playerStage if its the Players Dragon
		{
			dragon.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			if (playerStage) 
			{
				this.dragon = dragon;
				playerStage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
				playerStage.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
			}
		}
		
		private function onEnterFrame(e:Event):void 
		{
			e.target.tick();
		}
		
		private function onKeyUp(e:KeyboardEvent):void 
		{
			switch(e.keyCode)
			{
				case _allowedUpKey :
					_allowedUpKey = 0;
					dragon.action = DragonAction.STOP;
				break;
				case 65: //Left
				case 37:
				case 68: //Right
				case 39:
					
				break;
				case 87: //Up
				case 38:
					
				break;
				case 83: //Down
				case 40:
					
				break;
				case 16: // left shift
				case 17: // left ctrl
				case 32: // space
					dragon.action = DragonAction.SHOT;
				break;
			}
		}
		
		private function onKeyDown(e:KeyboardEvent):void 
		{
			switch(e.keyCode)
			{
				case 65: //Left
				case 37:
					_allowedUpKey = e.keyCode;
					dragon.action = DragonAction.LEFT;
				break;
				case 68: //Right
				case 39:
					_allowedUpKey = e.keyCode;
					dragon.action = DragonAction.RIGHT;
				break;
				case 87: //Up
				case 38:
					dragon.action = DragonAction.JUMP;
				break;
				case 83: //Down
				case 40:
					
				break;
				case 16: // left shift
				case 17: // left ctrl
				case 32: // space
					
				break;
			}
		}
	}

}