package gameobjects 
{
	import controller.DragonAction;

	import flash.events.Event;
	/**
	 * Represents the Bubble shot
	 * 
	 * @author GS
	 */
	public final class Bubble extends GameObject
	{
		private var _from:Dragon;
		
		public function Bubble() 
		{
			super("gfx/bubble/bubble.swf");
		}
		
		override protected function init():void 
		{
			this.gotoAndStop(1);
			this.addEventListener(Event.ENTER_FRAME, onEnterFrameHitTest);
		}
		
		public function shot(from:Dragon):void
		{
			this._from = from;
			
			scaleX = from.scaleX;
			x = from.x;
			y = from.y;
			from.stage.addChild(this);
			
			gotoAndPlay(1);
		}
		
		private function onEnterFrameHitTest(e:Event):void 
		{
			if (mc.currentFrame == 1) return;
			
			var hitDragon:Dragon = cc.collisionWithDragons(this);
			if (hitDragon == null || hitDragon == this._from) return;
			
			mc.gotoAndStop(1);
			hitDragon.action = DragonAction.BOBBEL;
		}
	}

}