package gameobjects 
{
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	/**
	 * Setup the Level
	 * @author GS
	 */
	public class Level extends Sprite 
	{
		public function Level(xmlUrl:String) 
		{
			var urlLoader:URLLoader = new URLLoader();
			
			urlLoader.addEventListener(Event.COMPLETE, onXMLComplete);
			urlLoader.load(new URLRequest(xmlUrl));
			
			initBorders();
		}
		
		private function initBorders():void
		{
			var obs:Obstacle;
			var l:Loader = new Loader();
			
			l.load(new URLRequest("gfx/desert1.gif"));
			this.addChild(l);
			
			obs = new Obstacle("gfx/bottom.gif");
			obs.y = 584;
			this.addChild(obs);
			
			obs = new Obstacle("gfx/border.gif", true);
			this.addChild(obs);
			
			obs = new Obstacle("gfx/border.gif", true);
			obs.x = 784;
			this.addChild(obs);
		}
		
		private function addBrick(x:int, y:int, type:int, border:Boolean = false):void
		{
			var obs:Obstacle;
			
			obs = new Obstacle("gfx/brick"+type+".gif", border);
			obs.x = x;
			obs.y = y;
			this.addChild(obs);
		}
		
		private function onXMLComplete(e:Event):void 
		{
			var xml:XML = new XML(e.target.data);
			
			for each (var brick:XML in xml.brick)
			{
				addBrick(brick.x, brick.y, brick.type, Boolean(int(brick.@border)));
			}
		}
		
	}

}